package cn.com.tenlion.systembase.service.homicide;

import cn.com.tenlion.systembase.pojo.bos.homicide.HomicideBO;
import cn.com.tenlion.systembase.pojo.dtos.homicide.HomicideDTO;
import cn.com.tenlion.systembase.pojo.pos.homicide.HomicidePO;
import cn.com.tenlion.systembase.pojo.vos.homicide.HomicideVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IHomicideService
 * @Description: 命案基本信息
 * @Author: CodeFactory
 * @Date: 2021-10-19 10:20:09
 * @Version: 3.0
 **/
public interface IHomicideService {

    /**
     * 新增命案基本信息
     *
     * @param homicideVO
     * @return
     */
    void save(HomicideVO homicideVO);

    /**
     * 新增命案基本信息
     *
     * @param token
     * @param homicideVO
     * @return
     */
    void save(String token, HomicideVO homicideVO);

    /**
     * 新增命案基本信息
     *
     * @param homicideVO
     * @return homicideId
     */
    String saveReturnId(HomicideVO homicideVO);

    /**
     * 新增命案基本信息
     *
     * @param token
     * @param homicideVO
     * @return homicideId
     */
    String saveReturnId(String token, HomicideVO homicideVO);

    /**
     * 删除命案基本信息
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除命案基本信息
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除命案基本信息（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改命案基本信息
     *
     * @param homicideId
     * @param homicideVO
     * @return
     */
    void update(String homicideId, HomicideVO homicideVO);

    /**
     * 修改命案基本信息
     *
     * @param token
     * @param homicideId
     * @param homicideVO
     * @return
     */
    void update(String token, String homicideId, HomicideVO homicideVO);

    /**
     * 命案基本信息详情
     *
     * @param params 参数Map
     * @return
     */
    HomicideDTO get(Map<String, Object> params);

    /**
     * 命案基本信息详情
     *
     * @param homicideId
     * @return
     */
    HomicideDTO get(String homicideId);

    /**
     * 命案基本信息详情
     *
     * @param params 参数Map
     * @return
     */
    HomicideBO getBO(Map<String, Object> params);

    /**
     * 命案基本信息详情
     *
     * @param homicideId
     * @return
     */
    HomicideBO getBO(String homicideId);

    /**
     * 命案基本信息详情
     *
     * @param params 参数Map
     * @return
     */
    HomicidePO getPO(Map<String, Object> params);

    /**
     * 命案基本信息详情
     *
     * @param homicideId
     * @return
     */
    HomicidePO getPO(String homicideId);

    /**
     * 命案基本信息列表
     *
     * @param params
     * @return
     */
    List<HomicideDTO> list(Map<String, Object> params);

    /**
     * 命案基本信息列表
     *
     * @param params
     * @return
     */
    List<HomicideBO> listBO(Map<String, Object> params);

    /**
     * 命案基本信息列表
     *
     * @param params
     * @return
     */
    List<HomicidePO> listPO(Map<String, Object> params);

    /**
     * 命案基本信息分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<HomicideDTO>> listPage(ListPage page);

    /**
     * 命案基本信息统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}